// SCP Gamemode
// Author: Fluffy

forceRequiredAddOn("System_ReturnToBlockland");
forceRequiredAddOn("System_BlocklandGlass");
if(isObject(SCP_Blackout))
    SCP_Blackout.delete();
exec("./blackout.gui");
BLG_GDS.registerObject(SCP_Blackout);
RTB_registerGUI("Add-Ons/Gamemode_SCP/blackout.gui");

function SCP_ObjectInView(%player, %object)
{
	if(!isObject(%object))
		return 0;

	%eye = %player.getEyePoint();
	%to = posFromTransform(%object.getTransform());

	if(vectorDist(%eye, %to) < %range)
		return 0;

	%ray = containerRaycast(%eye,%to,$TypeMasks::StaticShapeObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType,%player);
	%col = getWord(%ray,0);
	if(isObject(%col) && %col == %object)
	{
		%pos = posFromRaycast(%ray);

		%resultant = vectorSub(%pos,%eye);
		%normal = vectorNormalize(%resultant);
		%resultRadians = mAtan(getWord(%normal,1),getWord(%normal,0));
		
		%eyeVec = %player.getEyeVector();
		%eyeRadians = mAtan(getWord(%eyeVec,1),getWord(%eyeVec,0));

		%resultDegrees = mRadToDeg(%resultRadians);
		%eyeDegrees = mRadToDeg(%eyeRadians);

		if(%resultDegrees >= %eyeDegrees - 50 && %resultDegrees <= %eyeDegrees + 50)
			return 1;
	}
	return 0;
}

function Player::EndBlink(%this) {
    %this.blink = false;
    %this.setWhiteOut(0);
    BLG_GDS.getDataObject(SCP_Blackout).pop(%this.client);
    commandToClient(%this.client, 'RTB_closeGUI', SCP_Blackout);
}

function Player::Blink(%this) {
    cancel(%this.blinksched);
    %this.setWhiteOut(1);
    if (%this.client.hasBLG)
        BLG_GDS.getDataObject(SCP_Blackout).push(%this.client);
    else
        commandToClient(%this.client, 'RTB_openGUI', SCP_Blackout);
    %this.blink = true;
    %this.setEnergyLevel(100);
    %this.blinksched = %this.schedule(300, EndBlink);
}

function SCP_PlayerCheckTick()
{
    cancel($SCP::CheckShed);
    
    if(!isObject(SCPBots))
    {
        new SimGroup(SCPBots);
        MissionCleanup.add(SCPBots);
    }
    
    for(%i = 0; %i < clientGroup.getCount(); %i++)
    {
        %client = clientGroup.getObject(%i);
        %player = %client.player;
        
        if(!isObject(%player))
            continue;
        
        if(SCPBots.getCount() < 1)
            continue;

        if (%player.getDatablock().getName() $= "PlayerSCPArmor" && %player.getEnergyLevel() >= %player.getDatablock().maxEnergy) {
            %player.blink();
        }
    }

    for (%i = 0;%i < SCPBots.getCount();%i++) {
        %botObject = SCPBots.getObject(%i);
        %botWatched = false;

        for (%j = 0;%j < ClientGroup.getCount();%j++) {
            %client = ClientGroup.getObject(%j);
            if (!%client.player.blink && SCP_ObjectInView(%client.player, %botObject)) {
                %botWatched = true;
            }
        }

        if(%botWatched) {
            // Nothing yet
        } else {            
            %botObject.setAimLocation(%botObject.target.getTransform());
            %botObject.doTeleport();    
        }
        
        if(getWord(%botObject.getTransform(), 2) < 0)
        {
            %botObject.setTransform("222 -127 5");
            //%botObject.setTransform("-73.6662 -11.6914 0.410205");
        }
    }

    $SCP::CheckShed = schedule(1000, 0, SCP_PlayerCheckTick);
}

function SCP_GenerateBot(%pos)
{
    if(SCPBots.getCount() > 1)
        return;
    
    if(strLen(%pos) < 1)
        // %pos = "222 -127 5"; // Old map
        %pos = "-72 -12 0.5 0 0 1 1.7";
        
    %obj = new AIPlayer()
    {
      dataBlock = SCP173Player;
    };
    SCPBots.add(%obj);

    %obj.setTransform(%pos);
    %obj.schedule(1000, StartPlayerSearch);
}

function AIPlayer::StartPlayerSearch(%this)
{
    cancel(%this.playerLookLoop);
    
    %dist = 1000;
    for(%i = 0; %i < clientGroup.getCount(); %i++)
    {
        if(isObject(%player = clientGroup.getObject(%i).player))
        {
            if((%distB = vectorDist(%this.getPosition(), %player.getPosition())) < %dist)
            {
                %closestplayer = %player;
                %dist = %distB;
            }
        }
    }
    if(isObject(%closestplayer))
    {
        %this.targetVictim(%closestplayer);
    }
    %this.playerLookLoop = %this.schedule(1000, StartPlayerSearch);
}

function AIPlayer::targetVictim(%this, %victim)
{
    %this.target = %victim;
    %victim.predator = %this;
    
    //if(%this.getMoveObject() == %victim)
        //return;
        
    //%this.setMoveObject(%victim);
    //%this.setMoveSpeed(4);
}

function AIPlayer::doTeleport(%this)
{
    %victim = %this.target;
    %bot = %this;
    
    if(!isObject(%victim))
        return;
    
    %bot.setAimLocation(%victim.getTransform());
        
    if(vectorDist(%bot.getTransform(), %victim.getTransform()) < 3)
    {
        %victim.setWhiteOut(0.7);
        %victim.kill();
        %victim.playAudio(0, "Snap" @ getRandom(1,2));
        %this.victim.scared = false;
        return;
        //messageAll('', "SCP-173 Killed " @ %victim.client.name @ "!");
    }
    
    %maxJumpDist = "10";
    %botPos = %bot.getTransform();
    %victimPos = %victim.getTransform();
    
    %a = vectorDist(%botPos, %victimPos);
    if(%a < %maxJumpDist)
    {
        %bot.setTransform(vectorAdd(%victimPos, "0 2 0"));
        %victim.playAudio(0, "Horror" @ getRandom(1,3));
        return;
    }
    %dec = %maxJumpDist / %a;
    
    %difference = vectorSub(%botPos, %victimPos);
    %x = getWord(%difference, 0);
    %y = getWord(%difference, 1);
    %z = getWord(%difference, 2);
    
    %x = %x * %dec;
    %y = %y * %dec;
    %z = %z * %dec;
    
    %x = getWord(%botPos, 0) - %x;
    %y = getWord(%botPos, 1) - %y;
    %z = getWord(%botPos, 2) - %z;
    
    %pos = %x SPC %y SPC (%z + 1);
    
    %spawnProtectA = "128 -18 0";
    %spawnProtectB = "104 42 40";
    
    //if(%x > getWord(%spawnProtectA, 0) && %x < getWord(%spawnProtectB, 0) && %y > getWord(%spawnProtectA, 1) && %y < getWord(%spawnProtectB, 1) && %z > getWord(%spawnProtectA, 2) && %z < getWord(%spawnProtectB, 2))
        //return;
    
    %bot.setTransform(%pos);
    
    
}
SCP_PlayerCheckTick();

package SCPPackage
{
    function GameConnection::BLGMessage(%this) {
        if (!%this.hasBLG) {
            messageClient(%this, '', "\c6It seems like you're not using BlocklandGlass.");
            messageClient(%this, '', "\c6Due to a bug in RTB you can't use your mouse while blinking unless you get it <a:github.com/downloads/BlocklandGlass/Blockland-Glass/System_BlocklandGlass.zip>\c4here</a>\c6.");
            messageClient(%this, '', "\c6Really, we're extremely sorry for the inconvenience.");
        }
    }

    function GameConnection::autoAdminCheck(%this) {
        %this.schedule(0, BLGMessage);
        return parent::autoAdminCheck(%this);
    }

	function GameConnection::createPlayer(%cl, %this)
	{ Parent::createPlayer(%cl, %this); }
	
	function Player::kill(%pl)
	{ Parent::kill(%pl); }
    function GameConnection::onDeath(%this, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n) {
        commandToClient(%this, 'RTB_closeGUI', SCP_Blackout);
        BLG_GDS.getDataObject(SCP_Blackout).pop(%this);
        %this.setWhiteOut(0);
        return parent::onDeath(%this, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n);
    }
    function serverCmdLight(%cl)
    {
        %cl.player.blink();
    }
    function GameConnection::onClientEnterGame(%this)
    {
        parent::onClientEnterGame(%this);
        %this.play2D(intro1);
    }
	function servercmdUseSprayCan(%cl, %id)
	{ if(!isObject(%cl.minigame)) Parent::servercmdUseSprayCan(%cl, %id); }
	
	function servercmdUseFXCan(%cl, %id)
	{ if(!isObject(%cl.minigame)) Parent::servercmdUseFXCan(%cl, %id); }
};
activatePackage(SCPPackage);


// Sounds

datablock AudioProfile(Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/snap1.wav";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(Snap2 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/snap2.wav";
};

datablock AudioProfile(Ambient1 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/ambient1.wav";
};

datablock AudioProfile(Ambient2 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/ambient2.wav";
};

datablock AudioProfile(Ambient3 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/ambient3.wav";
};

datablock AudioProfile(Ambient4 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/ambient4.wav";
};

//datablock AudioProfile(Ambient5 : Snap1)
//{
	//filename = "Add-Ons/Gamemode_SCP/sounds/Machine.ogg";
//};

datablock AudioProfile(Horror1 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/horror1.ogg";
};
datablock AudioProfile(Horror2 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/horror2.ogg";
};
datablock AudioProfile(Horror3 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/horror3.ogg";
};

datablock AudioProfile(intro1 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/intro1.ogg";
};

datablock AudioProfile(intro2 : Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/intro2.wav";
};

datablock AudioProfile(SCPDoorOpen: Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/SCPDoorOpen.wav";
};

datablock AudioProfile(SCPDoorClose: Snap1)
{
	filename = "Add-Ons/Gamemode_SCP/sounds/SCPDoorClose.wav";
};

function servercmdToggleSCPAmbience(%cl)
{
	if(!%cl.isSuperAdmin) return; $SCP::AmbienceOff = !$SCP::AmbienceOff;
	messageAll('MsgAdminForce', "\c3"@%cl.name@"\c2 turned SCP ambience "@($SCP::AmbienceOff?"<color:FF0000>off":"<color:00FF00>on")@"\c3.");
}

function SCP_AmbientLoop()
{
	cancel($SCP::SoundLoop);
	%list = new SimSet();
	%list.add(Ambient1);
	%list.add(Ambient2);
	%list.add(Ambient3);
	%list.add(Ambient4);
	%list.remove($SCP::LastSound);   //Previous method could cause an infinite loop
	%sound = %list.getObject(getRandom(0, %list.getCount() - 1));
	if(!$SCP::AmbienceOff)
	{
		$SCP::LastSound = %sound;
		serverPlay2D(%sound);
	}
	$SCP::SoundLoop = schedule(13000, 0, SCP_AmbientLoop);
}
SCP_AmbientLoop();

// Horrible Horrible creature

datablock PlayerData(SCP173 : PlayerStandardArmor)
{
    shapeFile = "Add-Ons/Gamemode_SCP/scp173v2.dts";
    uiName = "SCP - 173";
};

// Cutscene Shennanigans

// SCP_InitiateCutScene()

datablock PathCameraData(CamPath)    
{   
   mode = "";  
   shapeFile = "base/data/shapes/empty.dts";  
};

datablock PathCameraData(SCPCam)
{
    hi = false;
};

new Path(CamPath) {    
    isLooping = "0";    
    canSave = "1";    
    canSaveDynamicFields = "1";    
        
    new Marker() {    
      seqNum = "1";    
      type = "Normal";    
      msToNext = "400";    
      smoothingType = "Spline";    
      position = "-99.435 -1.5 0.4";    
      rotation = "0 0 1 1.58213";    
      scale = "1 1 1";    
      canSave = "1";    
      canSaveDynamicFields = "1";    
      speed = "1";    
    };
    new Marker() {    
      seqNum = "2";    
      type = "Normal";    
      msToNext = "5000";    
      smoothingType = "Spline";    
      position = "-83.46 -1.34 3";    
      rotation = "0 0 1 1.58213";    
      scale = "1 1 1";    
      canSave = "1";    
      canSaveDynamicFields = "1";    
      speed = "0.1";    
    }; 
    new Marker() {    
      seqNum = "3";    
      type = "Normal";    
      msToNext = "3000";    
      smoothingType = "Spline";    
      position = "-77.198 0.938 3";    
      rotation = "0 0 1 3.15503";    
      scale = "1 1 1";    
      canSave = "1";    
      canSaveDynamicFields = "1";    
      speed = "3";    
    }; 
    new Marker() {    
      seqNum = "4";    
      type = "Normal";    
      msToNext = "2000";    
      smoothingType = "Spline";    
      position = "-77.198 -10.49 3";    
      rotation = "0 0 1 3.15503";    
      scale = "1 1 1";    
      canSave = "1";    
      canSaveDynamicFields = "1";    
      speed = "4";    
    };
    new Marker() {    
      seqNum = "5";    
      type = "Normal";    
      msToNext = "5000";    
      smoothingType = "Spline";    
      position = "-82.37 -15.53 4";    
      rotation = "0 0 1 1.14477";    
      scale = "1 1 1";    
      canSave = "1";    
      canSaveDynamicFields = "1";    
      speed = "1";    
    };
};

function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function GameConnection::followCamPath(%this, %path)
{
    %obj = new PathCamera()
    {
        datablock = SCPCam;
    };
    
    SCPCams.add(%obj);
    
    %obj.followPath(%path);
    %obj.scopeToClient(%this);
    %this.setControlObject(%obj);
}

function PathCamera::followPath(%this, %path)  
{  
   %this.path = %path;  
   if (!(%this.speed = %path.speed))  
      %this.speed = 10;  
   if (%path.isLooping)  
      %this.loopNode = %path.getCount() - 2;  
   else  
      %this.loopNode = -1;  
     
   %this.pushPath(%path);     
   %this.popFront();  
}  
  
function PathCamera::pushPath(%this,%path)  
{  
   for (%i = 0; %i < %path.getCount(); %i++)  
      %this.pushNode(%path.getObject(%i));  
}  
  
function PathCamera::pushNode(%this,%node)  
{  
   if (!(%speed = %node.speed))  
      %speed = %this.speed;  
   if ((%type = %node.type) $= "")  
      %type = "Normal";  
   if ((%smoothing = %node.smoothing) $= "")  
      %smoothing = "Linear";  
   %this.pushBack(%node.position SPC %node.rotation,%speed,%type,%smoothing);  
}

function SCP_LoadCast()
{
    if(isObject(SCPCast))
        SCPCast.delete();
        
    new SimGroup(SCPCast);
    
    MissionCleanup.add(SCPCast);
    
    SCPBots.delete();
    
    %obj = new AIPlayer() // Guard
    {
        datablock = playerStandardArmor;
        position = "-71.2995 -1.68 4";
        rotation = "0 0 -1 1.57518";
    };
    %obj.setName("SCP_Guard");
    %obj.setTransform(%obj.position SPC %obj.rotation);
    SCPCast.add(%obj);
    
    %obj = new AIPlayer() // Victim 1
    {
        datablock = playerStandardArmor;
        position = "-81.8 1.25952 0.5";
        rotation = "0 0 1 2.19247";
    };
    %obj.setName("SCP_Victim1");
    %obj.setTransform(%obj.position SPC %obj.rotation);
    SCPCast.add(%obj);
    
    %obj = new AIPlayer() // Victim 2
    {
        datablock = playerStandardArmor;
        position = "-83.154 -1.3982 0.5";
        rotation = "0 0 1 1.47332";
    };
    %obj.setName("SCP_Victim2");
    %obj.setTransform(%obj.position SPC %obj.rotation);
    SCPCast.add(%obj);
    
    %obj = new AIPlayer() // SCP
    {
        datablock = SCP173;
        position = "-71.6451 -16.1852 0.5";
        rotation = "0 0 1 1.57734";
    };
    %obj.setName("SCP_SCP");
    %obj.setTransform(%obj.position SPC %obj.rotation);
    SCPCast.add(%obj);
    
    //Let's play dress-up
    SCP_Victim1.setDecalName("mod-prisoner");
    SCP_Victim2.setDecalName("mod-prisoner");
    SCP_Victim1.setFaceName("memeYaranika");
    SCP_Victim2.setFaceName("memeHappy");
    
    //And colours ( Yes I'm fucking english )
    SCP_Victim1.setNodeColor("chest", "1 0.5 0 1");
    SCP_Victim2.setNodeColor("chest", "1 0.5 0 1");
    SCP_Victim1.setNodeColor("larm", "1 0.5 0 1");
    SCP_Victim2.setNodeColor("larm", "1 0.5 0 1");
    SCP_Victim1.setNodeColor("rarm", "1 0.5 0 1");
    SCP_Victim2.setNodeColor("rarm", "1 0.5 0 1");
    SCP_Victim1.setNodeColor("pants", "0 0 0 1");
    SCP_Victim2.setNodeColor("pants", "0 0 0 1");
}

function SCP_InitiateCutScene()
{
    if(!isObject(SCPCams))
    {
        new SimGroup(SCPCams);
        MissionCleanup.add(SCPCams);
    }
    cancel($SCP::SoundLoop);
    SCP_LoadCast();
    serverPlay2D(intro1);
    
    for(%i = 0; %i < clientGroup.getCount(); %i++)
    {
        %client = clientGroup.getObject(%i);
        %client.followCamPath(CamPath);
        %client.player.setTransform("0 -7000 0");
    }
    
    schedule(8000, 0, SCP_BeginShow());
}

function SCP_BeginShow()
{
    if(!isObject(SCPCast))
        return;
        
    cancel($SCP::CastSched);
    
    if(vectorDist(SCP_Victim1.getTransform(), "-78.83 -10.67 0.401") < 1)
    {
        schedule(4000, 0, serverPlay2D, intro2);
        schedule(16000, 0, SCP_Cutscene_BlackOut1);
        
        SCP_Victim1.setAimObject(SCP_SCP);
        return;
    }
    if(vectorDist(SCP_Victim1.getTransform(), "-76.66 -8.377 0.401") < 1)
    {
        SCP_Victim1.setMoveDestination("-78.83 -10.67 0.401", 0);
        $SCP::CastSched = schedule(1000, 0, SCP_BeginShow);
        return;
    }
    if(vectorDist(SCP_Victim1.getTransform(), "-77.1 -0.92 0.401") < 1)
    {
        SCP_Victim1.setMoveDestination("-76.66 -8.377 0.401", 0);
        $SCP::CastSched = schedule(1000, 0, SCP_BeginShow);
        return;
    }
    if(vectorDist(SCP_Victim2.getTransform(), "-73.1 -9.45 0.401") < 1)
    {
        SCP_Victim1.setMoveDestination("-77.1 -0.92 0.401", 0);
        SCP_Victim2.setAimObject(SCP_SCP);
        $SCP::CastSched = schedule(1000, 0, SCP_BeginShow);
        return;
    }
    if(vectorDist(SCP_Victim2.getTransform(), "-76.66 -8.377 0.401") < 1)
    {
        SCP_Victim2.setMoveDestination("-73.1 -9.45 0.401", 0);
        $SCP::CastSched = schedule(1000, 0, SCP_BeginShow);
        return;
    }
    if(vectorDist(SCP_Victim2.getTransform(), "-77.1 -0.92 0.401") < 1)
    {
        SCP_Victim2.setMoveDestination("-76.66 -8.377 0.401", 0);
        $SCP::CastSched = schedule(1000, 0, SCP_BeginShow);
        return;
    }
    SCP_Victim2.schedule(100, setMoveDestination, "-76.66 -8.377 0.401", 0);
        
    $SCP::CastSched = schedule(1000, 0, SCP_BeginShow);
}

function SCP_CutsceneEnd()
{
    for(%i = 0; %i < clientGroup.getCount(); %i++)
    {
        %cl = clientGroup.getObject(%i);
        %cl.player.delete();
        %cl.instantRespawn();
    }
    SCPCams.delete();
    SCPCast.delete();
    
    SCP_AmbientLoop();
    
    SCP_GenerateBot();
}

// Misc Cutscene parts

function SCP_Cutscene_BlackOut1()
{
    _BlinkLight.setLight("");
    _BlinkLight.schedule(600, setLight, "PlayerLight");
    SCP_SCP.setTransform(SCP_Victim1.getTransform());
    SCP_Victim1.kill();
    SCP_SCP.setAimObject(SCP_Victim2);
    schedule(600, 0, serverPlay2d, Horror2);
    schedule(3000, 0, SCP_Cutscene_BlackOut2);
}

function SCP_Cutscene_BlackOut2()
{
    _BlinkLight.setLight("");
    _BlinkLight.schedule(1000, setLight, "PlayerLight");
    SCP_SCP.setTransform(SCP_Victim2.getTransform());
    SCP_Victim2.kill();
    schedule(1000, 0, serverPlay2d, Horror1);
    schedule(2000, 0, SCP_CutsceneEnd);
}

function SCP_PlayerCheckup(%player) //You have to call this for each player at the start
{
   cancel(%player.scpcheckup);
	if(!isObject(%player) || %player.getDatablock().getName() !$= "PlayerSCPArmor") return;
	%player.checkup = true;
	%energy = %player.getEnergyLevel();
	if(%energy <= 3 && %player.getState() !$= "Dead")
	{
		%player.Blink();
	}
	%player.scpcheckup = schedule(100, 0, "SCP_PlayerCheckup", %player);
}
function Player::onBlink(%this)
{
   //Call other stuff here!!!
   
   %this.isBlinking = 1;
   %this.mountImage(scpcoverimage,2);
   cancel(%this.unblink);
   %this.unblink = schedule(200,0,eval,%this@".isBlinking = 0;");
   cancel(%this.UnCover);
   %this.unCover = schedule(200,0,eval,%this@".unmountImage(2);");
}
datablock PlayerData(PlayerSCPArmor : PlayerStandardArmor)
{
	rechargeRate = -0.75;
	firstPersonOnly = 1;
	runEnergyDrain = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	uiName = "SCP Player";
	showEnergyBar = 1;
	jumpforce = 0;
	
	maxForwardSpeed = 4;
	maxBackwardSpeed = 4;
	maxSideSpeed = 4;
	maxForwardCrouchSpeed = 1.5; //Crouch is super slow, but you can make these 0 if you don't want the player to move while crouching
	maxBackwardCrouchSpeed = 1.5;
	maxSideCrouchSpeed = 1.5;
	maxUnderwaterForwardSpeed = 4;
	maxUnderwaterBackwardSpeed = 4;
	maxUnderwaterSideSpeed = 4;
	maxTools = 6;
	maxWeapons = 6;
};
datablock ShapeBaseImageData(scpcoverimage)
{
	shapeFile					= "./cover.dts";
	emap						   = true;
	mountPoint					= 5;
	size                   = "0 0 0";
	offset						= "0 0 0";
	eyeoffset 					= "0 0.2 0";
	rotation					   = eulerToMatrix( "0 0 0" );
	doColorShift = true;
	colorShiftColor = "1 1 1 1";
};
package scpplayer
{
	function PlayerSCPArmor::spawnPlayer(%this)
	{
		parent::spawnPlayer(%this);
		SCP_PlayerCheckup(%this);
	}
   function Armor::onTrigger(%data,%player,%slot,%io)
	{
		%client = %player.client;
      if(%slot == 2 && %io && %player.getDatablock().getName() $= "PlayerSCPArmor")
      {
        if(!%player.blink)
		{
			%player.setEnergyLevel(100);
			%player.blink();
		}
      }
		Parent::onTrigger(%data,%player,%slot,%io);
	}
	function Player::setDatablock(%this,%data)
	{
	   Parent::setDatablock(%this,%data);
	   if(%data.getName() $= "PlayerSCPArmor" && !%this.checkup)
	      SCP_PlayerCheckup(%this);
	}
};
activatepackage(scpplayer);

function tickthing()
{
	while(isEventPending($SCP::tickThing))
		cancel($SCP::tickThing);
		
	for(%i=0;%i<clientGroup.getCount();%i++)
	{
		%cl = clientGroup.getObject(%i);
		if(!%cl.player.checkup)
			SCP_PlayerCheckup(%cl.player);
	}
	$SCP::tickThing = schedule(1000,0,tickThing);
}
tickthing();

//-----------------------------------------------------------------------------
// SCP173 model
// He says hello
//-----------------------------------------------------------------------------

datablock TSShapeConstructor(PlayerDts)
{
   baseShape = "./SCP173.dts";
};         


// SCP Model
// I am sexy
// Allun Pentax

datablock TSShapeConstructor(SCP173Dts)
{
	sequence1  = "./L_root.dsq run";
	sequence2  = "./L_root.dsq walk";
	sequence3  = "./L_root.dsq back";
	sequence4  = "./L_root.dsq side";

	sequence5  = "./L_root.dsq crouch";
	sequence6  = "./L_root.dsq crouchRun";
	sequence7  = "./L_root.dsq crouchBack";
	sequence8  = "./L_root.dsq crouchSide";

	sequence9  = "./L_look.dsq look";
	sequence10 = "./L_root.dsq headside";
	sequence11 = "./L_root.dsq headUp";

	sequence12 = "./L_root.dsq jump";
	sequence13 = "./L_root.dsq standjump";
	sequence14 = "./L_root.dsq fall";
	sequence15 = "./L_root.dsq land";

	sequence16 = "./L_root.dsq armAttack";
	sequence17 = "./L_root.dsq armReadyLeft";
	sequence18 = "./L_root.dsq armReadyRight";
	sequence19 = "./L_root.dsq armReadyBoth";
	sequence20 = "./L_root.dsq spearready";  
	sequence21 = "./L_root.dsq spearThrow";

	sequence22 = "./L_root.dsq talk";  

	sequence23 = "./L_root.dsq death1"; 
	
	sequence24 = "./L_root.dsq shiftUp";
	sequence25 = "./L_root.dsq shiftDown";
	sequence26 = "./L_root.dsq shiftAway";
	sequence27 = "./L_root.dsq shiftTo";
	sequence28 = "./L_root.dsq shiftLeft";
	sequence29 = "./L_root.dsq shiftRight";
	sequence30 = "./L_root.dsq rotCW";
	sequence31 = "./L_root.dsq rotCCW";

	sequence32 = "./L_root.dsq undo";
	sequence33 = "./L_root.dsq plant";

	sequence34 = "./L_root.dsq sit";

	sequence35 = "./L_root.dsq wrench";
};    

datablock PlayerData(SCP173Player)
{
   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./SCP_173.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;
   cameraVerticalOffset = 2.3;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 99999;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 0 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed = 0;

   jumpForce = 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2.5 2.5 1.7", 4); 
   crouchBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 
   proneBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = playerJetEmitter;
   jetGroundEmitter = playerJetGroundEmitter;
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 0;
   maxJumpSpeed = 0;

   horizMaxSpeed = 0;
   horizResistSpeed = 0;
   horizResistFactor = 0;

   upMaxSpeed = 0;
   upResistSpeed = 0;
   upResistFactor = 0;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= HorseJumpSound;

   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "SCP173";
	rideable = true;
   lookUpLimit = 0.6;
   lookDownLimit = 0.4;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

function SCP_addSCPBot(%obj)
{
	SCPBots.add(%obj);
	%obj.schedule(1000, StartPlayerSearch);
}

package	SCPVehicle
{
	function SCP173Player::onAdd(%this,%obj)
	{
		parent::onAdd(%this,%obj);
		schedule(2000,0,SCP_addSCPBot,%obj);
	}
};
activatepackage(SCPVehicle);